#include <vector>
#include <queue>
#include <list>
#include <algorithm>
#include <iterator>
#include <iostream>
using namespace std;

int kvad(int x) {
	return x*x;
}

class Kvadrerare {
public:
	int operator() (int x) const {
		return x*x;
	}
};


int main () {
	if (true) {
	int a[] = {5, 6, 7, 8, 9};
	vector<int> v(a, a+4);                // v = {5, 6, 7, 8}
	deque<int> d(6, 1);                   // d = {1, 1, 1, 1, 1, 1}
	copy(v.begin(), v.end(), d.begin());  // d = {5, 6, 7, 8, 1, 1}

	if (find(d.begin(), d.end(), 8) != d.end())
		cout << "finns" << endl;
	// d.end() r pos. efter d's sista element
	}


	if (true) {
	int a[] = {4, 5, 6, 7, 8, 9};
	list<int> e; //Obs! e r tom
	copy(a, a+4, back_inserter(e));
	// e = {4, 5, 6, 7}
	copy(a+2, a+6, front_inserter(e));
	// e = {9, 8, 7, 6, 4, 5, 6, 7} (Obs! ordningen)
	list<int>::iterator it=e.begin();
	it++;
	copy(a+1, a+3, inserter(e, it));
	// e = {9, 5, 6, 8, 7, 6, 4, 5, 6, 7}
	}

	if (true) {
	int a[] = {1, 2, 3, 5, 8};
	vector<int> v(a, a+5);                // v = {1, 2, 3, 5, 8}
	vector<int> w; // w r tom!
	transform(v.begin(), v.end(), inserter(w, w.begin()), kvad);
	// w = {1, 4, 9, 25, 64}
	}

	if (true) {
	Kvadrerare k;    // k(x) returnerar x*x
	int a[] = {1, 2, 3, 5, 8};
	vector<int> v(a, a+5);                // v = {1, 2, 3, 5, 8}
	vector<int> ww;  // ww r ocks tom!
	transform(v.begin(), v.end(), inserter(ww, ww.begin()), k);
	// ww = {1, 4, 9, 25, 64}
	}

	cin >> ws;
}
